#include <bits/stdc++.h>
#include "testlib.h"
#define ff first
#define ss second
#define szof(_x) ((int) (_x).size())

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
const int INF = 1e9 + 7;
const ll INFL = 1e18 + 123;
const double PI = atan2(0, -1);

int main(int argc, char* argv[]) {
	registerGen(argc, argv, 1);

	int n;
	cin >> n;
	vector<pii> edges;
	vector<vector<int>> graph(n);
	for (int i = 0; i < n - 1; ++i) {
		int u, v;
		cin >> u >> v;
		--u; --v;
		edges.push_back({u, v});
		graph[u].push_back(v);
		graph[v].push_back(u);
	}

	vector<int> sz(n);
	vector<int> parent(n);

	function<void(int, int)> dfs = [&](int v, int p) {
		parent[v] = p;
		sz[v] = 1;
		for (int to : graph[v]) {
			if (to != p) {
				dfs(to, v);
				sz[v] += sz[to];
			}
		}
	};

	dfs(0, 0);

	cout << "1\n";

	cout << n << "\n";

	const int MAXV = 1000000000;
	int single_weight = MAXV / n;

	for (int i = 0; i < n; ++i) {
		int a = rnd.next(1, single_weight);
		int b = rnd.next(1, n);
		if (i) {
			b = rnd.next(1, sz[parent[i]]);
		}

		int c = rnd.next(1, min(MAXV, single_weight * (b + 1)));

		cout << a << " " << b << " " << c << "\n";
	}

	for (pii e : edges) {
		cout << e.ff + 1 << " " << e.ss + 1 << "\n";
	}

	return 0;
}