#ifdef LOCAL
#  define _GLIBCXX_DEBUG
#  define _GLIBCXX_DEBUG_PEDANTIC
#endif

#include "bits/stdc++.h"
#define ff first
#define ss second
#define szof(_x) ((int) (_x).size())
#define TASK_NAME ""

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
const int INF = 1e9 + 7;
const ll INFL = 1e18 + 123;
const double PI = atan2(0, -1);
mt19937 tw(960172);
ll rnd(ll x, ll y) { static uniform_int_distribution<ll> d; return d(tw) % (y - x + 1) + x; }


void solve() {
	int k;
	cin >> k;
	string s, t;
	cin >> s >> t;
	if (szof(s) < k) {
		cout << "No\n";
		return;
	}

	vector<int> cnt_let(26);
	for (int i = 0; i < k; ++i) {
		cnt_let[s[i] - 'a']++;
	}

	vector<int> cnt_let_t(26);
	for (char c : t) {
		cnt_let_t[c - 'a']++;
	}

	int cnt_ok = 0;
	for (int i = 0; i < 26; ++i) {
		cnt_ok += cnt_let[i] <= cnt_let_t[i];
	}

	function<void(int, int)> change = [&](int pos, int val) {
		cnt_ok -= cnt_let[pos] <= cnt_let_t[pos];
		cnt_let[pos] += val;
		cnt_ok += cnt_let[pos] <= cnt_let_t[pos];
	};

	for (int i = 0; i + k <= szof(s); ++i) {
		if (cnt_ok == 26) {
			cout << "Yes\n";
			return;
		}
		if (i + k < szof(s)) {
			change(s[i] - 'a', -1);
			change(s[i + k] - 'a', 1);
		}
	}

	cout << "No\n";
}


int main() {
	//freopen(TASK_NAME ".in", "r", stdin);
	//freopen(TASK_NAME ".out", "w", stdout);
	cerr << fixed << setprecision(15);
	cout << fixed << setprecision(15);
	ios::sync_with_stdio(false);

	int tests = 1;
	// cin >> tests;
	for (int it = 1; it <= tests; ++it) {
		solve();
	}
	
	#ifdef LOCAL
		cerr << "time: " << clock() << " ms\n";
	#endif
	return 0;
}