#include <iostream>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <vector>
#include <string>

using namespace std;

#define TASK ""
typedef long long ll;
const int INF = (int)1e9 + 23;
const ll LINF = (ll)1e18 + 23;

int solve();

int main() {
	ios_base::sync_with_stdio(0);
#ifdef home
	freopen("input.txt", "r", stdin), freopen("output.txt", "w", stdout);
#else 
	cin.tie(0);
	cout.tie(0);
	if (TASK != "") freopen(TASK".in", "r", stdin), freopen(TASK".out", "w", stdout);
#endif
	solve();
	return 0;
}

int solve() {
	int n, m;
	cin >> n >> m;

	if (!n && !m) cout << -1, exit(0);

	if (n > m) swap(n, m);

	int x = sqrt(2 * n) + 1;
	if (x % 2 == 1 && n >= x * x / 2 && m >= x * x / 2 + 1) cout << x;
	else cout << x - 1;
	
	return 0;
}