#include <bits/stdc++.h>
#include "testlib.h"
#define ff first
#define ss second
#define szof(_x) ((int) (_x).size())

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
const int INF = 1e9 + 7;
const ll INFL = 1e18 + 123;
const double PI = atan2(0, -1);

vector<int> arr;

int check_outp(auto& stream, auto bad_outcome) {
	int k = stream.readInt();
	if (k == -1) {
		return k;
	}
	if (k < 0) {
		quitf(bad_outcome, "amount of steps is negative");
	}

	int bpv = 1;
	while (bpv < szof(arr)) {
		bpv *= 2;
	}

	vector<int> segtree(bpv * 2, -1);

	for (int i = 0; i < szof(arr); ++i) {
		segtree[bpv + i] = arr[i];
	}

	function<void(int, int, int, int, int, int)> segtree_set = [&](int v, int vl, int vr, int l, int r, int val) {
		if (vr <= l || r <= vl) {
			return;
		}
		if (l <= vl && vr <= r) {
			segtree[v] = val;
			return;
		}
		if (segtree[v] != -1) {
			segtree[v * 2] = segtree[v * 2 + 1] = segtree[v];
			segtree[v] = -1;
		}

		int vm = (vl + vr) / 2;
		segtree_set(v * 2, vl, vm, l, r, val);
		segtree_set(v * 2 + 1, vm, vr, l, r, val);
	};

	function<int(int, int, int, int, int)> segtree_get = [&](int v, int vl, int vr, int l, int r) {
		if (vr <= l || r <= vl) {
			return 0;
		}
		if (l <= vl && vr <= r) {
			return segtree[v];
		}
		if (segtree[v] != -1) {
			segtree[v * 2] = segtree[v * 2 + 1] = segtree[v];
			segtree[v] = -1;
		}

		int vm = (vl + vr) / 2;
		return segtree_get(v * 2, vl, vm, l, r) + segtree_get(v * 2 + 1, vm, vr, l, r);
	};

	for (int i = 0; i < k; ++i) {
		int l = stream.readInt(1, szof(arr)) - 1;
		int r = stream.readInt(l, szof(arr)) - 1;
		if (segtree_get(1, 0, bpv, l, l + 1) != segtree_get(1, 0, bpv, r, r + 1)) {
			quitf(bad_outcome, "values on ends don't equal");
		}
		segtree_set(1, 0, bpv, l, r + 1, segtree_get(1, 0, bpv, l, l + 1));
	}

	for (int i = 0; i < szof(arr) - 1; ++i) {
		if (segtree_get(1, 0, bpv, i, i + 1) > segtree_get(1, 0, bpv, i + 1, i + 2)) {
			quitf(bad_outcome, "array doesn't increase");
		}
	}
	return k;
}

int main(int argc, char* argv[]) {
	setName("compare two outputs");
	registerTestlibCmd(argc, argv);

	int n = inf.readInt();
	
	for (int i = 0; i < n; ++i) {
		int num = inf.readInt();
		arr.push_back(num);
	}

	int jans = check_outp(ans, _fail);
	int pans = check_outp(ouf, _wa);

	if (jans == -1 && pans != -1) {
		quitf(_fail, "participant found solution");
	}

	if (jans != -1 && pans == -1) {
		quitf(_wa, "participant didn't find solution");
	}

	if (jans == pans && jans == -1) {
		quitf(_ok, "solution doesn't exist");
	}

	if (jans < pans) {
		quitf(_wa, "jury have better solution");
	}

	if (jans > pans) {
		quitf(_fail, "participant found better solution");
	}

	quitf(_ok, "solution is correct");

	return 0;
}