#include <iostream>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <vector>
#include <string>

using namespace std;

#define TASK ""
typedef long long ll;
const int INF = (int)1e9 + 23;
const ll LINF = (ll)1e18 + 23;

int solve();

int main() {
	ios_base::sync_with_stdio(0);
#ifdef home
	freopen("input.txt", "r", stdin), freopen("output.txt", "w", stdout);
#else 
	cin.tie(0);
	cout.tie(0);
	if (TASK != "") freopen(TASK".in", "r", stdin), freopen(TASK".out", "w", stdout);
#endif
	solve();
	return 0;
}

const int dd = (int)1e6 + 3;
int x[dd], r[dd], c[dd];
int solve() {

	int n; cin >> n;
	for (int i = 0; i < n; i++) {
		cin >> x[i] >> r[i] >> c[i];
	}

	long long sum = 0;
	int ans = 1;
	for (int i = 0; i + 1 < n; i++) {
		sum += x[i] + r[i] * c[i];
		if (sum < x[i + 1]) ans++, sum = 0;
	}

	cout << ans;
	return 0;
}