#include <bits/stdc++.h>
using namespace std;
typedef long long ll;

vector<ll> f(int n, vector<pair<int, int>> ed) {
  mt19937 rnd(228);
  vector<int> deg(n);
  for (auto o : ed) {
    deg[o.first]++;
    deg[o.second]++;
  }
  vector<int> coef(5);
  for (int i = 0; i < (int)coef.size(); i++) coef[i] = rnd();

  vector<ll> cur(n);
  for (int i = 0; i < n; i++) {
    if (deg[i] < 2 || deg[i] > 4) return vector<ll>();
    cur[i] = coef[deg[i]];
  }
  for (int it = 0; it < 10; it++) {
    vector<ll> ncur(n);
    for (auto o : ed) {
      ncur[o.first] += cur[o.second];
      ncur[o.second] += cur[o.first];
    }
    cur = ncur;
  }
  sort(cur.begin(), cur.end());
  return cur;
}

bool iso(int n, vector<pair<int, int>> e1, vector<pair<int, int>> e2) {
  return f(n, e1) == f(n, e2);
}

int main() {
  int n, m;
  while (scanf("%d%d", &n, &m) == 2) {
    vector<pair<int, int>> e1, e2;
    for (int i = 0; i < n * (m - 1) + (n - 1) * m; i++) {
      int u, v;
      scanf("%d%d", &u, &v);
      u--; v--;
      e1.push_back({u, v});
    }
    for (int i = 0; i < n; i++) {
      for (int j = 0; j < m; j++) {
        if (j < m - 1) e2.push_back({i * m + j, i * m + (j + 1)});
        if (i < n - 1) e2.push_back({i * m + j, (i + 1) * m + j});
      }
    }
    const string ans[] = {"NO", "YES"};
    cout << ans[iso(n * m, e1, e2)] << endl;
  } 
}