#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <cstring>

using namespace std;

int solve();

#define ss second
#define ff first
#define y1 y111
#define all(x) (x).begin(), (x).end()
#define sz(x) ((int)((x).size()))
#define mp make_pair

typedef long long ll;

int main() {
	ios_base::sync_with_stdio(0);
#ifdef home
	freopen ("input.txt", "r", stdin);
	freopen ("output.txt", "w", stdout);
#endif
	solve();
	return 0;
}

int get(string &s) {
	reverse(s.begin(), s.end());

	ll p = 0;

	for (int i = 0; i < sz(s); ++i) {

		ll cur = p;

		if (i < sz(s)) {
			cur += s[i] - '0';
		}

		ll lcur = cur;
		cur += (cur % 10) * (10 / __gcd(10ll, cur % 10) - 1);
		p = cur / 10;

		if (lcur == cur / 10 && lcur < 10 && i == sz(s) - 1) {
			return lcur;
		}
	}

	while (p) {
		ll cur = p;
		ll lcur = cur;
		cur += (cur % 10) * (10 / __gcd(10ll, cur % 10) - 1);
		p = cur / 10;

		if (lcur == cur / 10 && lcur < 10) {
			return lcur;
		}
	}
	return p;
}

int solve() {
	int t;
	cin >> t;

	while (t--) {
		string s;
		cin >> s;
		cout << get(s) << "\n";
	}

	return 0;
}