#ifdef LOCAL
#  define _GLIBCXX_DEBUG
#  define _GLIBCXX_DEBUG_PEDANTIC
#endif

#include "bits/stdc++.h"
#define ff first
#define ss second
#define szof(_x) ((int) (_x).size())
#define TASK_NAME ""

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
const int INF = 1e9 + 7;
const ll INFL = 1e18 + 123;
const double PI = atan2(0, -1);
mt19937 tw(960172);
ll rnd(ll x, ll y) { static uniform_int_distribution<ll> d; return d(tw) % (y - x + 1) + x; }


void solve() {
	string s;
	cin >> s;
	reverse(s.begin(), s.end());
	ll carry = 0;
	for (int i = 0; carry || i < szof(s); ++i) {
		// cerr << i << " " << carry << endl;
		ll cur = carry;
		if (i < szof(s)) {
			cur += s[i] - '0';
		}
		int dig = cur % 10;
		if (i >= szof(s) - 1 && cur < 10 && __gcd(10, dig) == 1) {
			cout << cur << "\n";
			break;
		}
		int mult = 10 / __gcd(10, dig);
		cur += dig * (mult - 1);
		assert(cur % 10 == 0);
		carry = cur / 10;
	}
}


int main() {
	//freopen(TASK_NAME ".in", "r", stdin);
	//freopen(TASK_NAME ".out", "w", stdout);
	cerr << fixed << setprecision(15);
	cout << fixed << setprecision(15);
	ios::sync_with_stdio(false);

	int tests = 1;
	cin >> tests;
	for (int it = 1; it <= tests; ++it) {
		solve();
	}
	
	#ifdef LOCAL
		cerr << "time: " << clock() << " ms\n";
	#endif
	return 0;
}