#include <iostream>
#include <vector>

using namespace std;

int main() {
#ifdef DEBUG
    freopen("input", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);

    int n, m, q;
    cin >> n >> m >> q;
    vector<vector<int>> col(n, vector<int> (m));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            col[i][j] = ((i + j) & 1);
        }
    }

    while (q--) {
        int x, y;
        cin >> x >> y;
        x--;
        y--;
        col[x][y] = 1 - col[x][y];

        int best = n * m;
        int cur = 0;
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                if (col[i][j] == 1) {
                    cur++;
                }
            }
        }
        best = min(best, cur);
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                if (col[i][j] == 1) {
                    cur--;
                } else {
                    cur++;
                }
            }
            best = min(best, cur);
        }

        cout << best << "\n";
    }

    return 0;
}