#include <bits/stdc++.h>
#include "testlib.h"
#define ff first
#define ss second
#define szof(_x) ((int) (_x).size())

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
const int INF = 1e9 + 7;
const ll INFL = 1e18 + 123;
const double PI = atan2(0, -1);

const int MAXN = 5000;
const int MAXV = 1000000000;
const int MAXT = 5000;

int main(int argc, char* argv[]) {
	registerValidation(argc, argv);

	int t = inf.readInt(1, MAXT, "t");
	inf.readEoln();
	int sumn = 0;

	for (int q = 0; q < t; ++q) {
		int n = inf.readInt(1, MAXN, "n");
		sumn += n;
		inf.readEoln();
		for (int i = 0; i < n; ++i) {
			inf.readInt(1, MAXV, "a");
			inf.readSpace();
			inf.readInt(1, n, "b");
			inf.readSpace();
			inf.readInt(1, MAXV, "c");
			inf.readEoln();
		}

		vector<vector<int>> graph(n);
		for (int i = 0; i < n - 1; ++i) {
			int u = inf.readInt(1, n, "u") - 1;
			inf.readSpace();
			int v = inf.readInt(1, n, "v") - 1;
			graph[v].push_back(u);
			graph[u].push_back(v);
			inf.readEoln();
		}

		vector<bool> used(n);

		function<void(int)> dfs = [&](int v) {
			used[v] = true;
			for (int to : graph[v]) {
				if (!used[to]) {
					dfs(to);
				}
			}
		};

		dfs(0);

		for (int i = 0; i < n; ++i) {
			ensuref(used[i], "graph must be connected");
		}
	}

	ensuref(sumn <= MAXN, "sum of n shouldn't exceed %d", MAXN);

	inf.readEof();

	return 0;
}