#ifdef LOCAL
#  define _GLIBCXX_DEBUG
#  define _GLIBCXX_DEBUG_PEDANTIC
#endif

#include "bits/stdc++.h"
#define ff first
#define ss second
#define szof(_x) ((int) (_x).size())
#define TASK_NAME ""

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
const int INF = 1e9 + 7;
const ll INFL = 1e18 + 123;
const double PI = atan2(0, -1);
mt19937 tw(960172);
ll rnd(ll x, ll y) { static uniform_int_distribution<ll> d; return d(tw) % (y - x + 1) + x; }


void solve() {
	int n;
	cin >> n;
	vector<pair<int, pii>> inp;
	for (int i = 0; i < n; ++i) {
		int a, b, c;
		cin >> a >> b >> c;
		inp.push_back({a, {b, c}});
	}

	vector<vector<int>> tree(n);

	for (int i = 1; i < n; ++i) {
		int u, v;
		cin >> u >> v;
		--u; --v;
		tree[u].push_back(v);
		tree[v].push_back(u);
	}

	vector<int> sz(n);
	vector<vector<int>> all(n);

	function<ll(int, int)> dfs = [&](int v, int p) {
		auto it = find(tree[v].begin(), tree[v].end(), p);
		if (it != tree[v].end()) {
			tree[v].erase(it);
		}
		sz[v] = 1;
		ll sum = inp[v].ff;
		for (int to : tree[v]) {
			sum += dfs(to, v);
			sz[v] += sz[to];
			for (int num : all[to]) {
				all[v].push_back(num);
			}
		}

		auto arr = all[v];

		for (int to : tree[v]) {
			all[v].push_back(inp[to].ff);
		}

		arr.push_back(inp[v].ff);
		sort(arr.begin(), arr.end());

		assert(szof(arr) == sz[v] - szof(tree[v]));

		for (int i = 0; i < 1 << szof(tree[v]); ++i) {
			ll need = 0;
			ll profit = 0;
			auto cur = arr;
			for (int j = 0; j < szof(tree[v]); ++j) {
				if (i & (1 << j)) {
					need += inp[tree[v][j]].ss.ff;
					profit += inp[tree[v][j]].ss.ss;
				} else {
					cur.push_back(inp[tree[v][j]].ff);
				}
			}
			if (need <= sz[v] - __builtin_popcount(i)) {
				sort(cur.begin(), cur.end());
				profit += accumulate(cur.begin() + need, cur.end(), 0ll);
				sum = max(sum, profit);
			}
		}

		// cerr << v << " " << sum << endl;
		return sum;
	};

	cout << dfs(0, 0) << "\n";
}


int main() {
	//freopen(TASK_NAME ".in", "r", stdin);
	//freopen(TASK_NAME ".out", "w", stdout);
	cerr << fixed << setprecision(15);
	cout << fixed << setprecision(15);
	ios::sync_with_stdio(false);

	int tests = 1;
	cin >> tests;
	for (int it = 1; it <= tests; ++it) {
		solve();
	}
	
	#ifdef LOCAL
		cerr << "time: " << clock() << " ms\n";
	#endif
	return 0;
}