#ifdef LOCAL
#  define _GLIBCXX_DEBUG
#  define _GLIBCXX_DEBUG_PEDANTIC
#endif

#include "bits/stdc++.h"
#define ff first
#define ss second
#define szof(_x) ((int) (_x).size())
#define TASK_NAME ""

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
const int INF = 1e9 + 7;
const ll INFL = 1e18 + 123;
const double PI = atan2(0, -1);
mt19937 tw(960172);
ll rnd(ll x, ll y) { static uniform_int_distribution<ll> d; return d(tw) % (y - x + 1) + x; }


void solve() {
	int n;
	cin >> n;
	vector<pair<int, pii>> inp;
	for (int i = 0; i < n; ++i) {
		int a, b, c;
		cin >> a >> b >> c;
		inp.push_back({a, {b, c}});
	}

	vector<vector<int>> tree(n);

	for (int i = 0; i < n - 1; ++i) {
		int u, v;
		cin >> u >> v;
		--u; --v;
		tree[u].push_back(v);
		tree[v].push_back(u);
	}

	vector<int> sz(n);

	function<pair<ll, multiset<int>>(int, int)> dfs = [&](int v, int p) {
		auto it = find(tree[v].begin(), tree[v].end(), p);
		if (it != tree[v].end()) {
			tree[v].erase(it);
		}
		// cerr << v << endl;
		sz[v] = 1;
		ll ret = inp[v].ff;
		multiset<int> have;
		for (int to : tree[v]) {
			auto tmp = dfs(to, v);
			ret += tmp.ff;
			if (szof(have) < szof(tmp.ss)) {
				swap(have, tmp.ss);
			}
			for (int num : tmp.ss) {
				have.insert(num);
			}
			sz[v] += sz[to];
		}

		have.insert(inp[v].ff);

		int shift = szof(tree[v]);
		vector<ll> best(sz[v] + 1 + shift, -INF);
		best[shift] = 0;
		for (int to : tree[v]) {
			vector<ll> next(sz[v] + 1 + shift, -INF);
			for (int i = 0; i + inp[to].ss.ff < szof(best); ++i) {
				next[i + inp[to].ss.ff] = max(next[i + inp[to].ss.ff], best[i] + inp[to].ss.ss);
			}
			for (int i = 0; i < szof(best); ++i) {
				next[i] = max(next[i], best[i] + inp[to].ff);
				if (i) {
					next[i - 1] = max(next[i - 1], best[i]);
				}
			}
			swap(best, next);
		}

		ll sum = 0;
		for (int num : have) {
			sum += num;
		}

		int c = 0;
		for (int num : have) {
			best[c + shift] += sum;
			sum -= num;
			++c;
		}

		have.erase(have.find(inp[v].ff));
		for (int to : tree[v]) {
			have.insert(inp[to].ff);
		}

		// cerr << v << " " << max(ret, *max_element(best.begin(), best.begin() + c + 1)) << endl;

		return make_pair(max(ret, *max_element(best.begin() + shift, best.begin() + shift + c + 1)), have);
	};

	cout << dfs(0, 0).ff << "\n";
}


int main() {
	//freopen(TASK_NAME ".in", "r", stdin);
	//freopen(TASK_NAME ".out", "w", stdout);
	cerr << fixed << setprecision(15);
	cout << fixed << setprecision(15);
	ios::sync_with_stdio(false);

	int tests = 1;
	cin >> tests;
	for (int it = 1; it <= tests; ++it) {
		solve();
	}
	
	#ifdef LOCAL
		cerr << "time: " << clock() << " ms\n";
	#endif
	return 0;
}